module Ecoportal
  module API
    module Common
      module Content
        class WrappedResponse < Common::WrappedResponse
          include Enumerable

          attr_reader :response, :result

          def initialize(response, klass, key: nil)
            @response = response
            @klass    = klass
            @key      = key

            if @response.success?
              @result =
                if data.is_a?(Array)
                  data.map do |doc|
                    @klass.new(doc)
                  end
                else
                  @klass.new(data)
                end
            end
          end

          def data
            return @data if instance_variable_defined?(:@data)
            @data = (response.body || {})["data"]
            @data = @data[@key] if @key && @data
            @data
          end

          def body
            data.to_s
          end

        end
      end
    end
  end
end
