module Ecoportal
  module API
    class V2
      class Page
        class Stage < Common::Content::DoubleModel
          passkey     :id
          passforced  :patch_ver, default: 1
          passthrough :name, :ordering
          passarray   :subtags, order_matters: false
          passarray   :section_ids
          passthrough :status
          passboolean :complete, :lock_after_completion

          embeds_many :permits, klass: "Ecoportal::API::V2::Page::Permit"
          passboolean :disable_direct_permissions
          passboolean :creator_enabled, :creator_editable
          embeds_one  :creator_flags, klass: "Ecoportal::API::V2::Page::PermissionFlags"
          passthrough :can

          def sections
            sec_ids = section_ids.to_a
            root.sections.values_at(*sec_ids).select.with_index do |sec, i|
              puts "Warning: section #{id} points to missing section #{sec_ids[i]}" if !sec
              fld && (!block_given? || yield(sec))
            end.sort_by.with_index {|sec, index| [sec.weight, index]}
          end

          def add_section(*secs)
            secs.each {|sec| section_ids.insert_one(sec.id)}
            self
          end

        end
      end
    end
  end
end
