module Ecoportal
  module API
    class V2
      class Pages
        class PageStage < V2::Page
          passthrough :mould_counter, :archive
          passthrough :task_priority, :state, :status
          passthrough :votes_enabled, :upvotes, :downvotes

          embeds_many :permits, klass: "Ecoportal::API::V2::Page::Permit"
          passarray   :force_errors, :subtags, order_matters: false

          # `id` of the stage we got the data of.
          def current_stage_id
            doc.dig("active_stage", "id") || doc["current_stage_id"]
          end

          # @return [Ecoportal::API::V2::Page::Stage]
          def current_stage
            if stage_id = current_stage_id
              stages[stage_id]
            end
          end

        end
      end
    end
  end
end
