module Ecoportal
  module API
    class V2
      # @attr_reader client [Common::Client] a `Common::Client` object that holds the configuration of the api connection.
      class People < API::Internal::People

        def batch
          unavailable_method!(__method__)
        end

        def job
          unavailable_method!(__method__)
        end

        private

        # Re-using hook to obtain the raw data response
        def body_data(body)
          return body unless body.is_a?(Hash)
          return body unless body.key?("data")
          body["data"]
        end

        def unavailable_method!(str)
          raise "Unavailable method '#{str}' for api '#{VERSION}'"
        end

      end
    end
  end
end
