module Ecoportal
  module API
    class V2
      class Registers
        class Register < Common::Content::DoubleModel
          passkey     :id
          passthrough :name

          class_resolver :template_class, "Ecoportal::API::V2::Registers::Template"

          def templates_by_id
            @templates_by_id or index_templates
            @templates_by_id
          end

          def [](id)
            templates_by_id[id]
          end

          def templates
            templates_by_id.values
          end

          def index_templates
            @templates_by_id   = {}
            doc["templates"].each do |template_doc|
              template = template_class.new(template_doc)
              @templates_by_id[template.id] = template
            end
          end

        end

      end
    end
  end
end
